<?php
/**
 * CMQLogRoute class file.
 *
 * @author spall
 * @version 1.0
 */

class CMQLogRoute extends CLogRoute
{
	/**
	 * @var string the ID of MQ application component. 
	 */
	public $mqID='mq';

	/**
         * @var string  name of MQ exchange for publish 
	 */
	public $mqExchange="yiilog";

	private $_mq;

	/**
	 * Initializes the route.
	 * This method is invoked after the route is created by the route manager.
	 */
	public function init()
	{
		parent::init();
		$this->_mq = Yii::app()->getComponent($this->mqID);
	}

	/**
	 * Stores log messages into mq.
	 * @param array list of log messages
	 */
	protected function processLogs($logs)
	{
		$ex = $this->_mq->exchange($this->mqExchange);
		foreach($logs as $log)
		{
			$log[] = Yii::App()->name;
			$ex->publish( json_encode($log), Yii::App()->name);
		}
	}
}
